/*

        TCXLDEMO.C  - A demonstration program of the TCXL function library.

                        (c) 1987, 1988  by Mike Smedley

        To compile:

            from the command line type:  tcc tcxldemo tcxl.lib
                                              or:
                                         make -ftcxldemo

                                    or:

            from the environment, specify 'TCXLDEMO.PRJ' as the Project Name

*/

#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include "tcxldef.h"
#include "tcxlkey.h"
#include "tcxlvid.h"
#include "tcxlwin.h"

void interrupt exit_prog(void);
void error_exit(void);

int row,col,*sbuf1;                                    /*  global variables  */

main() 
{
    register int i,j;
    int ch;
    int whandle[10];
    int *sbuf2;
    char *fname="        ";
    char *mi=" ";
    char *lname="              ";
    char *phone="          ";
    char *pressakey="Press a key";
    char *spaces=  "           ";


    videoinit();                    /*  initialize video  */
    sbuf1=ssave();                  /*  save current screen contents  */
    if(!sbuf1) error_exit();
    readcur(&row,&col);             /*  save current cursor position  */
    setcursz(32,0);                 /*  turn off cursor  */
    setvect(0x23,&exit_prog);       /*  redirect Ctrl-Break interrupt  */
    setcbrk(ON);                    /*  set Ctrl-Break checking on  */
    for(;;) {

        /*  open up opening screen windows  */

        for(i=0;i<6;i++) {
            whandle[i]=wopen(i,i+10,i+13,i+47,3,LCYAN|_BLUE);
            if(!whandle[i]) error_exit();

            /*  sound tones of increasing pitch  */

            sound_(12000-((i+1)*1500),2);
        }

        wprints(0,16,LRED,"TCXL");
        wprints(1,2,LGREEN,"An Extended Library of Functions");
        wprints(2,12,LGREEN,"for Turbo C");
        wprints(4,10,YELLOW,"by Mike Smedley");
        wprints(6,0,LMAGENTA,"(c) 1987, 1988 - All Rights Reserved");
        wprints(8,7,WHITE,"Demonstration Program");
        wprints(10,7,LCYAN|_BLUE,"Press any key to begin");

        /*  change colors of prompt until a key is pressed  */

        i=LBLUE;
        for(;;) {
            gotoxy_(16,22);
            setattr(i|_BLUE,23);
            delay_(2);
            if(kbhit()) {
                ch=getch();
                break;
            }
            i++;
            if(i>WHITE) i=LBLUE;
        }
        if(ch==ESC) exit_prog();             /*  see if Esc key was pressed  */
        wprints(10,7,_BLUE,"                       ");

        /*  scroll the window's text up and out of the window  */

        for(i=0;i<10;i++) {
            wscroll(1,UP);
            delay_(2);
        }

        /*  close all open windows */

        for(i=5;i>=0;i--) {
            wclose();
            delay_(2);
        }


        /*  open demo window 0 and demonstrate text wraparound and
            scrolling from within a window                          */

        whandle[0]=wopen(1,1,11,41,0,LMAGENTA|_RED);
        if(!whandle[0]) error_exit();
        wtextattr(LCYAN|_RED);
        wprintf("\n TCXL's window display functions like"
                "\n wprintf() & wputs() allow wrap-around"
                "\n and scrolling from within windows.");
        wprints(7,14,YELLOW|BLINK|_RED,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(7,14,_RED,spaces);
        wgotoxy(8,0);
          for(i=0;i<15;i++) {
            if(kbhit()) {
                if(getch()==ESC) exit_prog();
                break;
            }
            for(j=DGREY;j<=WHITE;j++) {
                wtextattr(j|_RED);
                wputs("TCXL   ");
                delay_(1);
            }
        }


        /*  open demo window 1 and demonstrate changing of window attribute  */

        whandle[1]=wopen(14,35,23,65,2,YELLOW|_BLUE);
        if(!whandle[1]) error_exit();
        wtextattr(LCYAN|_BLUE);
        wputs("\n  The wchgattr() function"
              "\n  allows you to change the"
              "\n  attribute of the active"
              "\n  window.");
        wprints(6,9,YELLOW|BLINK|_BLUE,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(6,9,_BLUE,spaces);
        wchgattr(WHITE|_GREEN);
        delay_(12);
        wchgattr(LMAGENTA|_RED);
        delay_(12);
        wchgattr(LCYAN|_BLUE);
        if(kbhit()) {                               /*  check for keypress  */
            if(getch()==ESC) exit_prog();
        }
        delay_(12);
        wchgattr(YELLOW|_MAGENTA);
        delay_(12);
        wchgattr(WHITE|_LGREY);
        delay_(12);

        /*  open demo window 2 and demonstrate resizing of windows         */

        whandle[2]=wopen(5,20,19,45,3,LCYAN|_GREEN);
        if(!whandle[2]) error_exit();
        wtextattr(WHITE|_GREEN);
        wputs("\n  The wsize() function"
              "\n  allows you to resize"
              "\n  the active window.");
        wprints(6,6,YELLOW|BLINK|_GREEN,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(6,6,_GREEN,spaces);
        wsize(19,60);
        delay_(12);;
        wsize(19,75);
        delay_(12);;
        wsize(24,75);
        delay_(12);;
        wsize(24,60);
        delay_(12);;
        wsize(24,45);
        delay_(12);;
        wsize(19,45);
        delay_(12);;


        /*  open demo window 3 and demonstrate multi-field keyboard input  */

        whandle[3]=wopen(12,10,23,50,1,LCYAN|_BLUE);
        if(!whandle[3]) error_exit();
        wtextattr(LMAGENTA|_BLUE);
        wputs("\n    The winpdef() and winpread()"
              "\n    functions allow multi-field"
              "\n    keyboard input.");
        wprints(3,21,YELLOW|BLINK|_BLUE,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(3,21,_BLUE,spaces);
        wprints(5,2,LCYAN|_BLUE,"First name?");
        if(winpdef(5,15,fname,'M',BLACK|_LGREY)) error_exit();
        wprints(5,26,LCYAN|_BLUE,"MI?");
        if(winpdef(5,31,mi,'U',BLACK|_LGREY)) error_exit();
        wprints(7,2,LCYAN|_BLUE,"Last name?");
        if(winpdef(7,15,lname,'M',BLACK|_LGREY)) error_exit();
        wtextattr(LGREEN|_BLUE);
        setcursz(6,7);                          /*  turn cursor on  */
        i=winpread();
        setcursz(32,0);                         /*  turn cursor back off  */
        if(i) exit_prog();                      /*  check for Esc press  */


        /*  open demo window 4 and demonstrate controlled keyboard input  */

        whandle[4]=wopen(8,41,16,78,0,WHITE|_MAGENTA);
        if(!whandle[4]) error_exit();
        wtextattr(LGREEN|_MAGENTA);
        wputs("\n  For complete control of keyboard"
              "\n  input, there is the winputsf()"
              "\n  function.  ");
        wprints(3,13,YELLOW|BLINK|_MAGENTA,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(3,13,_MAGENTA,spaces);
        wtextattr(WHITE|_MAGENTA);
        setcursz(6,7);                                   /*  turn cursor on  */
        i=winputsf(phone," '\n\n  Phone number?  ' !R-! "
            " !-! '(' !+! ### !-! ') ' !+! ### !-! '-' !+! #### ");
        setcursz(32,0);                            /*  turn cursor back off  */
        if(i) exit_prog();                      /*  check for Esc press  */

        /*  clear window 4 and demonstrate bar selection menus  */

        wclear();
        wsize(22,78);
        wtextattr(LGREEN|_MAGENTA);
        wputs("\n  TCXL also has bar-selection menus"
              "\n  thanks to wmbardef() and"
              "\n  wmbarget().");
        wprints(3,15,YELLOW|BLINK|_MAGENTA,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(3,15,YELLOW|_MAGENTA,"Select one ");
        wmbardef(5,3,LCYAN|_MAGENTA,"Add record",'A');
        wmbardef(5,18,LCYAN|_MAGENTA,"Show record",'S');
        wmbardef(7,3,LCYAN|_MAGENTA,"Delete record",'D');
        wmbardef(7,18,LCYAN|_MAGENTA,"Update record",'U');
        wmbardef(9,3,LCYAN|_MAGENTA,"Print record",'P');
        wmbardef(9,18,LCYAN|_MAGENTA,"Quit program",'Q');
        i=wmbarget(LCYAN|_LGREY);
        wprints(3,15,_MAGENTA,spaces);
        if(i=='Q'||!i) exit_prog();
        wgotoxy(11,10);
        wtextattr(WHITE|_MAGENTA);
        wprintf("You selected %c!",i);
        delay_(54);

        /*  open demo window 5 and demonstrate screen swapping  */

        whandle[5]=wopen(3,3,12,33,0,YELLOW|_BLACK);
        if(!whandle[5]) error_exit();
        wtextattr(LCYAN|_BLACK);
        wputs("\n  The ssave() and srestore()"
              "\n  functions allow screen"
              "\n  swapping to/from memory.");
        wprints(5,8,LRED|BLINK|_BLACK,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(5,8,_BLACK,spaces);
        sbuf2=ssave();
        if(!sbuf2) error_exit();
        gotoxy_(24,79);
        clrscrn();
        prints(10,27,LMAGENTA,"Press a key to return");
        if(waitkey()==ESC) exit_prog();
        srestore(sbuf2);


        /*  open demo window 6 and demonstrate activating of windows  */

        whandle[6]=wopen(11,48,21,77,1,LCYAN|_CYAN);
        wtextattr(WHITE|_CYAN);
        wputs("\n TCXL's wactiv() is used to"
              "\n activate a window, making"
              "\n it available for windowing"
              "\n operations.");
        wprints(4,14,YELLOW|BLINK|_CYAN,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(4,14,_CYAN,spaces);
        for(i=0;i<=6;i++) {
            if(kbhit()) {                            /*  check for keypress  */
                if(getch()==ESC) exit_prog();
            }
            if(wactiv(whandle[i])) error_exit();
            delay_(15);
        }


        /*  open demo window 7 and demonstrate moving of active window  */

        whandle[7]=wopen(4,2,16,35,2,LGREEN|_BROWN);
        if(!whandle[7]) error_exit();
        wtextattr(WHITE|_BROWN);
        wputs("\n To move the active window,"
              "\n the wmove() function is"
              "\n used.");
        wprints(3,8,YELLOW|BLINK|_BROWN,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(3,8,_BROWN,spaces);
        if(wmove(0,0)) error_exit();
        delay_(12);
        if(wmove(10,4)) error_exit();
        delay_(12);
        if(wmove(6,19)) error_exit();
        delay_(12);
        if(kbhit()) {                               /*  check for keypress  */
            if(getch()==ESC) exit_prog();
        }
        if(wmove(1,13)) error_exit();
        delay_(12);
        if(wmove(2,35)) error_exit();
        delay_(12);
        if(wmove(11,35)) error_exit();
        delay_(12);


        /*  demonstrate making copies of the same window  */

        wtextattr(LRED|_BROWN);
        wputs("\n\n The wcopy() function will"
                "\n create a duplicate of the"
                "\n active window.");
        wprints(7,17,YELLOW|BLINK|_BROWN,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(7,17,_BROWN,spaces);
        whandle[8]=wcopy(0,0);
        if(!whandle[8]) error_exit();
        delay_(12);
        whandle[9]=wcopy(1,37);
        if(!whandle[9]) error_exit();
        if(kbhit()) {                               /*  check for keypress  */
            if(getch()==ESC) exit_prog();
        }
        delay_(18);
        wclose();                                      /*  close copies  */
        delay_(12);
        wclose();
        delay_(12);


        /*  close all windows except window 0  */

        while(wnopen()>1) {
            if(kbhit()) {
                if(getch()==ESC) exit_prog();
            }
            wclose();
            delay_(6);
        }


        /*  list other features of TCXL  */

        wclear();
        wputs("  Other features of TCXL include:\n");
        wtextattr(LGREEN|_RED);
        wputs("\n  - EGA 43 & VGA 50 line modes"
              "\n  - expanded memory usage"
              "\n  - screen/window swapping to disk"
              "\n  - advanced string manipulation"
              "\n  - equipment detection"
              "\n  - mouse functions"
              "\n  - printer functions");
        wprints(8,26,YELLOW|BLINK|_RED,pressakey);
        if(waitkey()==ESC) exit_prog();
        wprints(8,26,_RED,spaces);


        /*  get response from the keyboard, controlling input  */

        wclear();
        if(wmove(7,19)) error_exit();
        wgotoxy(3,11);
        wtextattr(WHITE|_RED);
        wputs("View demo again?  ");
        setcursz(7,1);                           /*  turn cursor on  */
        clearkeys();                             /*  clear keyboard buffer  */
        ch=wgetchf("YyNn");                      /*  get keyboard response  */
        setcursz(32,0);                          /*  turn cursor back off  */
        if(ch==ESC) exit_prog();                 /*  see if Esc was pressed  */
        wclose();
        if(ch=='Y'||ch=='y') {
        }
        else {
            exit_prog();
        }
    }
}

/*  if the Esc key or Ctrl-Break is pressed, this function will be called  */ 

void interrupt exit_prog(void)
{
    clearkeys();                       /*  clear keyboard buffer  */
    setcursz(6,7);                     /*  set cursor size back to normal  */
    srestore(sbuf1);                   /*  restore original screen  */
    gotoxy_(row,col);                  /*  restore original cursor position  */
    exit(0);
}

/*  if an error occurs, this function will be called  */

void error_exit(void)
{
    setcursz(6,7);                       /*  set cursor size back to normal  */
    if(_werrno) {
        printf("\nError:  %s      ",werrmsg());    /*  display error message */
    }
    else {
        abort();
    }
    exit(1);
}


